### Method

# FwupdPlugin Device cleanup

#### Declaration [src]

    gboolean
    fu_device_cleanup (
      FuDevice* self,
      FuProgress* progress,
      FwupdInstallFlags flags,
      GError** error
    )

#### Description [src]

Cleans up a device after an update. A different plugin can handle each of FuDevice->write_firmware(), FuDevice->attach() and FuDevice->cleanup().

Available since: | 1.3.3

#### Parameters

`progress` | `FuProgress`
| A `FuProgress`.
| The data is owned by the caller of the function.
`flags` | `FwupdInstallFlags`
| Install flags.
`error` | `GError **`
| The return location for a `GError*`, or `NULL`.

#### Return value

Returns: | `gboolean`
| `TRUE` on success.